import Taro from "@tarojs/taro";
import store from "@/store"

export function subscribeMessage(messageType) {
  if (!messageType) return Promise.resolve();
  
  const { messageTpls } = store.getModel('system').getState()
  if (!messageTpls || !messageTpls.length) return Promise.resolve();

  return new Promise((resolve, reject) => {
    const tpl = messageTpls.filter(x => x.messageType === messageType)[0] || {}

    if (tpl.templateId) {
      Taro.requestSubscribeMessage({
        tmplIds: [tpl.templateId],
        complete: () => resolve(),
      })
    } else {
      resolve()
    }
  })
}

export function withSubscribeMessage(type, callback) {
  subscribeMessage(type).then(() => {
    if (callback) {
      callback()
    }
  })
}
